unit UFichePrincipale;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ToolWin, ImgList, StdCtrls, Buttons, ExtCtrls;

type
  TfrmGestionEntreprise = class(TForm)
    GrpFiliales: TGroupBox;
    Label1: TLabel;
    ListBoxFiliales: TListBox;
    BtnAjouterFiliale: TSpeedButton;
    GroupBox1: TGroupBox;
    EdLocalisation: TEdit;
    Label2: TLabel;
    EdTauxAnciennete: TEdit;
    Label3: TLabel;
    BtnSupprimerFiliale: TSpeedButton;
    StatusApplication: TStatusBar;
    GroupBox2: TGroupBox;
    ListBoxEmployes: TListBox;
    GroupBox3: TGroupBox;
    BtnSuppEmploye: TSpeedButton;
    BtnAjoutEmploye: TSpeedButton;
    RgTypeEmploye: TRadioGroup;
    Label4: TLabel;
    EdNomEmploye: TEdit;
    Label5: TLabel;
    EdSalaireBase: TEdit;
    PanelAnciennete: TPanel;
    Label6: TLabel;
    EdAnciennete: TEdit;
    PanelPrime: TPanel;
    Label7: TLabel;
    EdPrime: TEdit;
    PanelCA: TPanel;
    Label8: TLabel;
    EdCA: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnAjouterFilialeClick(Sender: TObject);
    procedure ListBoxFilialesClick(Sender: TObject);
    procedure BtnSupprimerFilialeClick(Sender: TObject);
    procedure RgTypeEmployeClick(Sender: TObject);
    procedure BtnAjoutEmployeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BtnSuppEmployeClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmGestionEntreprise: TfrmGestionEntreprise;

implementation

uses UClassesGestionEntreprise;

{$R *.DFM}

procedure TfrmGestionEntreprise.FormCreate(Sender: TObject);
begin
 //crer une instance d'entreprise
 Entreprise:= TEntreprise.Create;
end;

procedure TfrmGestionEntreprise.FormDestroy(Sender: TObject);
begin
 //fin de l'application -> fin de l'entreprise
 Entreprise.Free;
end;

procedure TfrmGestionEntreprise.BtnAjouterFilialeClick(Sender: TObject);
Var Filiale: TFiliale;
begin
 //cration d'une instance de filiale
 Filiale:= TFiliale.Create;
 //rcuprer les paramtres - OK ?
 If Filiale.OkRecupParametres(EdLocalisation.Text,EdTauxAnciennete.Text)
  Then
   Begin
    //vrifier les doublons
    If Entreprise.FilialeExiste(Filiale)
     Then
      Begin
       StatusApplication.SimpleText:= 'Doublons parmi les filiales';//message d'erreur - toujours important !!!
       Filiale.Free;//pas de piti
      End
     Else
      Begin
       //si on est ici, c'est que tout va bien
       Entreprise.AjouterFiliale(Filiale);//ajouter la filiale dans la liste
       Entreprise.RafraichirAffichage(ListBoxFiliales);//mettre  jour l'affichage !!!
       StatusApplication.SimpleText:= 'Ajout de filiale avec succs';//message
       //comme aucune filiale n'est slectionne, vider la liste des employs s'il y en a
       ListBoxEmployes.Items.Clear;
      End;
   End
  Else
   Begin
    StatusApplication.SimpleText:= 'Mauvais paramtres de filiales';//message d'erreur - toujours important !!!
    Filiale.Free;//pas de piti
   End;
end;

procedure TfrmGestionEntreprise.ListBoxFilialesClick(Sender: TObject);
Var Filiale: TFiliale;
begin
 //si une slection est ralise
 If (ListBoxFiliales.ItemIndex>=0)
  Then
   Begin
    //afficher les paramtres de cette filiale
    Filiale:= Entreprise.RecupererFiliale(ListBoxFiliales.ItemIndex);
    EdLocalisation.Text:= Filiale.Localisation;
    EdTauxAnciennete.Text:= Filiale.stringTauxRemuneration;
    //afficher les mploys corresp.
    Filiale.AffichageLstEmployes(ListBoxEmployes);
   End;
end;

procedure TfrmGestionEntreprise.BtnSupprimerFilialeClick(Sender: TObject);
begin
 //une filiale est-elle slectionne ?
 If (ListBoxFiliales.ItemIndex>=0)
  Then
   Begin
    Entreprise.DetruireFiliale(ListBoxFiliales.ItemIndex);//suppression
    Entreprise.RafraichirAffichage(ListBoxFiliales);//rafrachir l'affichage
    StatusApplication.SimpleText:= 'Suppression effectue';
   End
  Else StatusApplication.SimpleText:= 'Pas de filiale slectionne';
end;

procedure TfrmGestionEntreprise.RgTypeEmployeClick(Sender: TObject);
begin
 //afficher tous les panels
 PanelAnciennete.Visible:= TRUE;
 PanelPrime.Visible:= TRUE;
 PanelCA.Visible:= TRUE;
 //cacher slectivement les panels
 Case RgTypeEmploye.ItemIndex Of
  0: Begin
      PanelPrime.Visible:= False;
      PanelCA.Visible:= false;
     End;
  1: PanelCA.Visible:= false;
  2: Begin
      PanelAnciennete.Visible:= false;
      PanelPrime.Visible:= false;
     End;
 End;
end;

procedure TfrmGestionEntreprise.BtnAjoutEmployeClick(Sender: TObject);
Var Filiale: TFiliale;
    Employe: TEmploye;
    okSaisie: Boolean;
begin
 //crer une instance et effectuer la saisie
 Case RgTypeEmploye.ItemIndex of
  //employ de bureau
  0: Begin
      Employe:= TEmployeBureau.Create;
      okSaisie:= (Employe as TEmployeBureau).okRecupValeurs(EdNomEmploye.Text,EdSalaireBase.Text,EdAnciennete.Text);
     End;
  //cadre
  1: Begin
      Employe:= TCadre.Create;
      okSaisie:= (Employe as TCadre).okRecupValeurs(EdNomEmploye.Text,EdSalaireBase.Text,EdAnciennete.Text,EdPrime.Text);
     End;
  //commercial
  2: Begin
      Employe:= TCommercial.Create;
      okSaisie:= (Employe as TCommercial).okRecupValeurs(EdNomEmploye.Text,EdSalaireBase.Text,EdCa.Text);
     End;
 End;
 //mauvaise saisie ????
 If not(okSaisie)
  Then
   Begin
    StatusApplication.SimpleText:= 'mauvaise saisie des paramtres';
    Employe.Free;
   End
  Else
   Begin
    //la saisie est correcte, on va rcuprer la filiale
    If (ListBoxFiliales.ItemIndex<0)
     Then
      Begin
       StatusApplication.SimpleText:= 'pas de filiale d''affectation';
       Employe.Free;
      End
     Else
      Begin
       //on peut affecter la filiale
       Filiale:= Entreprise.RecupererFiliale(ListBoxFiliales.ItemIndex);
       Employe.Filiale:=Filiale;
       //insertion dans la liste de la filiale
       Filiale.AjouterEmploye(Employe);
       //rafrachir toujours l'affichage
       Filiale.AffichageLstEmployes(ListBoxEmployes);
      End;
   End;
end;

procedure TfrmGestionEntreprise.FormShow(Sender: TObject);
begin
 RgTypeEmploye.ItemIndex:= 0;//pour dclencher le camouflage des panels de saisie
end;

procedure TfrmGestionEntreprise.BtnSuppEmployeClick(Sender: TObject);
Var Filiale: TFiliale;
begin
 If (ListBoxEmployes.ItemIndex>=0)
  Then
   Begin
    //rcuprer la filiale concerne
    If (ListBoxFiliales.ItemIndex>=0)
     Then
      Begin
       //on peut affecter la filiale
       Filiale:= Entreprise.RecupererFiliale(ListBoxFiliales.ItemIndex);
       //et suppression
       Filiale.SeDefaireEmploye(ListBoxEmployes.ItemIndex);
      End
     Else StatusApplication.SimpleText:= 'aucune filiale slectionne';
   End
  Else StatusApplication.SimpleText:= 'slection employ recquise';
end;

end.
